diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererDefault.java
index 41592bc9b..37458f6e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererDefault.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 public class EntityRendererDefault extends EntityRenderer<Entity> {
     @Override
-    public void render(@NotNull final Tessellator tessellator, @NotNull final Entity entity, final double x, final double y, final double z,
+    public void render(@NotNull final TessellatorGeneral tessellator, @NotNull final Entity entity, final double x, final double y, final double z,
                        final float yaw, final float partialTick) {
-        GL11.glPushMatrix();
+        GLRenderer.pushFrame();
         renderOffsetAABB(tessellator, entity.bb, x - entity.xo, y - entity.yo, z - entity.zo);
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
index 5a3948fa2..0bc021248 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
@@ -4,48 +4,46 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.world.BlocksContainer;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
-public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBlock>
-{
+public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBlock> {
     private final Minecraft mc;
     private BlocksContainer container = null;
 
 
-    public EntityRendererFallingBlock()
-    {
+    public EntityRendererFallingBlock() {
         super(0.5f);
         this.mc = Minecraft.getMinecraft();
     }
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @NotNull EntityFallingBlock fallingBlock, double x, double y, double z, float yaw, float partialTick) {
+    public void render(@NotNull TessellatorGeneral tessellator, @NotNull EntityFallingBlock fallingBlock, double x, double y, double z, float yaw, float partialTick) {
         if (this.container == null || this.container.world != fallingBlock.world) {
             this.container = new BlocksContainer(fallingBlock.world);
         }
-        GL11.glPushMatrix();
-        GL11.glTranslated(x, y, z);
-        TextureRegistry.blockAtlas.bind();
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        TextureRegistry.worldAtlas.bind();
         Lighting.disable();
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glDisable(GL11.GL_CULL_FACE);
-        if(this.mc.isAmbientOcclusionEnabled())
-        {
-            GL11.glShadeModel(GL11.GL_SMOOTH);
-        } else
-        {
-            GL11.glShadeModel(GL11.GL_FLAT);
-        }
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.disableState(State.CULL_FACE);
+//        if (this.mc.isAmbientOcclusionEnabled()) {
+//            GL11.glShadeModel(GL11.GL_SMOOTH);
+//        } else {
+//            GL11.glShadeModel(GL11.GL_FLAT);
+//        }
 
         TilePos blockPos = new TilePos(fallingBlock);
 
@@ -54,7 +52,7 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
 
         this.container.setLightReferenceEntity(fallingBlock);
         this.container.setBlock(blockPos.x, blockPos.y, blockPos.z, fallingBlock.carriedBlock.blockId, fallingBlock.carriedBlock.metadata, fallingBlock.carriedBlock.entity);
-        BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(fallingBlock.carriedBlock.blockId)).renderNoCulling(Tessellator.instance, this.container, blockPos);
+        BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(fallingBlock.carriedBlock.blockId)).renderNoCulling(GLRenderer.getTessellator(), this.container, blockPos);
         this.container.setLightReferenceEntity(null);
         this.container.clear();
 
@@ -62,13 +60,13 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
         tessellator.draw();
 
         Lighting.enableLight();
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
 
         TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(fallingBlock.carriedBlock.entity);
         if (renderer != null) {
-            GL11.glPushMatrix();
+            GLRenderer.pushFrame();
             renderer.doRender(tessellator, fallingBlock.carriedBlock.entity, x - 0.5, y - 0.5, z - 0.5, partialTick);
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
index 58317c50e..01795afdd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
@@ -15,7 +17,7 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
     }
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @NotNull EntityFishingBobber entity, double x, double y, double z, float yaw, float partialTick) {
+    public void render(@NotNull TessellatorGeneral tessellator, @NotNull EntityFishingBobber entity, double x, double y, double z, float yaw, float partialTick) {
         super.render(tessellator, entity, x, y, z, yaw, partialTick);
         if (entity.owner != null) {
             int handedNess = entity.owner.isLeftHanded() ? -1 : 1;
@@ -44,16 +46,16 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
             double ya = (float) (yp - yh);
             double za = (float) (zp - zh);
             GL11.glDisable(GL11.GL_TEXTURE_2D);
-            GL11.glDisable(GL11.GL_LIGHTING);
-            tessellator.startDrawing(3);
-            tessellator.setColorOpaque_I(0);
+            GLRenderer.globalSetLightEnabled(false);
+            tessellator.startDrawing(DrawMode.LINE_STRIP);
+            tessellator.setColorOpaque1i(0);
             for (int i = 0, steps = 16; i <= steps; i++) {
                 final float aa = (float) i / (float) steps;
                 tessellator.addVertex(x + xa * (double) aa, y + ya * (double) (aa * aa + aa) * 0.5D + 0.25D, z + za * (double) aa);
             }
 
             tessellator.draw();
-            GL11.glEnable(GL11.GL_LIGHTING);
+            GLRenderer.globalSetLightEnabled(true);
             GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java
index 62aa77466..2b6397bc3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java
@@ -1,24 +1,26 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class EntityRendererGeneric<T extends Entity> extends EntityRenderer<T>{
+public class EntityRendererGeneric<T extends Entity> extends EntityRenderer<T> {
     public final @NotNull StaticEntityModel entityModel;
+
     public EntityRendererGeneric(final @NotNull StaticEntityModel entityModel, final float shadowSize) {
         super(shadowSize);
         this.entityModel = entityModel;
     }
+
     @Override
-    public void render(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        GL11.glPushMatrix();
+    public void render(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GLRenderer.pushFrame();
         bindTexture("/assets/minecraft/textures/entity/creeper/0.png");
-        GL11.glTranslated(x, y, z);
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
         this.entityModel.resetBones();
-        this.entityModel.render(tessellator);
-        GL11.glPopMatrix();
+        this.entityModel.render();
+        GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
index c9861e379..58e1e346d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
@@ -1,56 +1,43 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.entity.EntityItem;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
-
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 
-import static org.lwjgl.opengl.GL11.glPushMatrix;
-
-public class EntityRendererItem extends EntityRenderer<EntityItem>
-{
-
+public class EntityRendererItem extends EntityRenderer<EntityItem> {
 
-	public EntityRendererItem() {
-		super(0.15f);
-		shadowOpacity = 0.75F;
-	}
+    public EntityRendererItem() {
+        super(0.15f);
+        this.shadowOpacity = 0.75F;
+    }
 
-	public void render(@NotNull Tessellator tessellator, final @NotNull EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-		float brightness = 1.0f;
-		if(!LightmapHelper.isLightmapEnabled()) {
-			brightness = entity.getBrightness(partialTick);
-		}
-		final ItemStack itemstack = entity.item;
-		if(itemstack == null) {
-			return;
-		}
-		Item item = itemstack.getItem();
-		if(item == null) {
-			return;
-		}
-		glPushMatrix();
-		final float bobbingOffset = MathHelper.sin((entity.age + partialTick) / 10F + entity.bobOffset) * 0.1F + 0.1F;
-		final float yw = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.bobOffset));
-		byte renderCount = 1;
-		if (entity.item.stackSize > 1) {
-			renderCount = 2;
-		}
-		if (entity.item.stackSize > 5) {
-			renderCount = 3;
-		}
-		if (entity.item.stackSize > 20) {
-			renderCount = 4;
-		}
-		GL11.glTranslated(x, y + bobbingOffset, z);
-		ItemModelDispatcher.getInstance().getDispatch(item).renderItemEntity(tessellator, itemstack, Minecraft.getMinecraft().gameSettings.items3D.value, renderCount, entity.age, yw, brightness, 1f, partialTick);
-		GL11.glPopMatrix();
-	}
+    public void render(@NotNull TessellatorGeneral tessellator, final @NotNull EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        final ItemStack itemstack = entity.item;
+        if (itemstack == null) {
+            return;
+        }
+        Item item = itemstack.getItem();
+        GLRenderer.pushFrame();
+        final float bobbingOffset = MathHelper.sin((entity.age + partialTick) / 10F + entity.bobOffset) * 0.1F + 0.1F;
+        final float yw = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.bobOffset));
+        byte renderCount = 1;
+        if (entity.item.stackSize > 1) {
+            renderCount = 2;
+        }
+        if (entity.item.stackSize > 5) {
+            renderCount = 3;
+        }
+        if (entity.item.stackSize > 20) {
+            renderCount = 4;
+        }
+        GLRenderer.modelM4f().translate((float) x, (float) (y + bobbingOffset), (float) z);
+        ItemModelDispatcher.getInstance().getDispatch(item).renderItemEntity(tessellator, itemstack, Minecraft.getMinecraft().gameSettings.items3D.value, renderCount, entity.age, yw, entity.getLightmap(partialTick), partialTick);
+        GLRenderer.popFrame();
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
index 75c6ff44a..ad6a23eae 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
@@ -2,106 +2,92 @@ package net.minecraft.client.render.entity;
 
 import java.util.Random;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.EntityLightning;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
-public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
-{
+public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning> {
 
-    public EntityRendererLightningBolt()
-    {
+    public EntityRendererLightningBolt() {
     }
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @NotNull EntityLightning lightning, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
+    public void render(@NotNull TessellatorGeneral tessellator, @NotNull EntityLightning lightning, double x, double y, double z,
+                       float yaw, float partialTick) {
         GL11.glDisable(GL11.GL_TEXTURE_2D);
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glEnable(GL11.GL_BLEND);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.enableState(State.BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
         double ad[] = new double[8];
         double ad1[] = new double[8];
         double d3 = 0.0D;
         double d4 = 0.0D;
         Random random = new Random(lightning.seed);
-        for(int j = 7; j >= 0; j--)
-        {
+        for (int j = 7; j >= 0; j--) {
             ad[j] = d3;
             ad1[j] = d4;
             d3 += random.nextInt(11) - 5;
             d4 += random.nextInt(11) - 5;
         }
 
-        for(int i = 0; i < 4; i++)
-        {
+        for (int i = 0; i < 4; i++) {
             random.setSeed(lightning.seed);
-            for(int k = 0; k < 3; k++)
-            {
+            for (int k = 0; k < 3; k++) {
                 int l = 7;
                 int i1 = 0;
-                if(k > 0)
-                {
+                if (k > 0) {
                     l = 7 - k;
                 }
-                if(k > 0)
-                {
+                if (k > 0) {
                     i1 = l - 2;
                 }
                 double d5 = ad[l] - d3;
                 double d6 = ad1[l] - d4;
-                for(int j1 = l; j1 >= i1; j1--)
-                {
+                for (int j1 = l; j1 >= i1; j1--) {
                     double d7 = d5;
                     double d8 = d6;
-                    if(k == 0)
-                    {
+                    if (k == 0) {
                         d5 += random.nextInt(11) - 5;
                         d6 += random.nextInt(11) - 5;
-                    } else
-                    {
+                    } else {
                         d5 += random.nextInt(31) - 15;
                         d6 += random.nextInt(31) - 15;
                     }
-                    tessellator.startDrawing(5);
+                    tessellator.startDrawing(DrawMode.TRIANGLE_STRIP);
                     float f2 = 0.5F;
-                    tessellator.setColorRGBA_F(0.9F * f2, 0.9F * f2, 1.0F * f2, 0.3F);
-                    double d9 = 0.1D + (double)i * 0.2D;
-                    if(k == 0)
-                    {
-                        d9 *= (double)j1 * 0.1D + 1.0D;
+                    tessellator.setColor4f(0.9F * f2, 0.9F * f2, 1.0F * f2, 0.3F);
+                    double d9 = 0.1D + (double) i * 0.2D;
+                    if (k == 0) {
+                        d9 *= (double) j1 * 0.1D + 1.0D;
                     }
-                    double d10 = 0.1D + (double)i * 0.2D;
-                    if(k == 0)
-                    {
-                        d10 *= (double)(j1 - 1) * 0.1D + 1.0D;
+                    double d10 = 0.1D + (double) i * 0.2D;
+                    if (k == 0) {
+                        d10 *= (double) (j1 - 1) * 0.1D + 1.0D;
                     }
-                    for(int k1 = 0; k1 < 5; k1++)
-                    {
+                    for (int k1 = 0; k1 < 5; k1++) {
                         double d11 = (x + 0.5D) - d9;
                         double d12 = (z + 0.5D) - d9;
-                        if(k1 == 1 || k1 == 2)
-                        {
+                        if (k1 == 1 || k1 == 2) {
                             d11 += d9 * 2D;
                         }
-                        if(k1 == 2 || k1 == 3)
-                        {
+                        if (k1 == 2 || k1 == 3) {
                             d12 += d9 * 2D;
                         }
                         double d13 = (x + 0.5D) - d10;
                         double d14 = (z + 0.5D) - d10;
-                        if(k1 == 1 || k1 == 2)
-                        {
+                        if (k1 == 1 || k1 == 2) {
                             d13 += d10 * 2D;
                         }
-                        if(k1 == 2 || k1 == 3)
-                        {
+                        if (k1 == 2 || k1 == 3) {
                             d14 += d10 * 2D;
                         }
-                        tessellator.addVertex(d13 + d5, y + (double)(j1 * 16), d14 + d6);
-                        tessellator.addVertex(d11 + d7, y + (double)((j1 + 1) * 16), d12 + d8);
+                        tessellator.addVertex(d13 + d5, y + (double) (j1 * 16), d14 + d6);
+                        tessellator.addVertex(d11 + d7, y + (double) ((j1 + 1) * 16), d12 + d8);
                     }
 
                     tessellator.draw();
@@ -111,9 +97,9 @@ public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
 
         }
 
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glEnable(GL11.GL_LIGHTING);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.globalSetLightEnabled(true);
         GL11.glEnable(GL11.GL_TEXTURE_2D);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index 639b54edf..7a37bb233 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -1,19 +1,18 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.Global;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Vector3d;
 import org.joml.Vector3dc;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 
 public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
     public EntityRendererMinecart() {
@@ -21,9 +20,9 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
     }
 
     @Override
-    public void render(@NotNull final Tessellator tessellator, @NotNull final EntityMinecart minecart, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glPushMatrix();
+    public void render(@NotNull final TessellatorGeneral tessellator, @NotNull final EntityMinecart minecart, final double x, final double y, final double z, final float yaw, final float partialTick) {
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.pushFrame();
 
         final double lerpX = MathHelper.lerp(minecart.xo, minecart.x, partialTick);
         final double lerpY = MathHelper.lerp(minecart.yo, minecart.y, partialTick);
@@ -67,34 +66,29 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
 
 //            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.8, z), Vec3.fromPool(velVec.x, velVec.y, velVec.z), 1.5, 0, 1, 1, 1);
         }
-        GL11.glTranslated(renderX, renderY, renderZ);
-        GL11.glRotated(180F - renderYaw, 0.0F, 1.0F, 0.0F);
-        GL11.glRotated(-lerpXRot, 0.0F, 0.0F, 1.0F);
+        GLRenderer.modelM4f().translate((float) renderX, (float) renderY, (float) renderZ);
+        GLRenderer.modelM4f().rotateY((float) org.joml.Math.toRadians(180F - renderYaw));
+        GLRenderer.modelM4f().rotateZ((float) org.joml.Math.toRadians(-lerpXRot));
         final double hurtAngle = minecart.timeSinceHit - partialTick;
         double currentDamage = minecart.currentDamage - partialTick;
         if (currentDamage < 0.0F) {
             currentDamage = 0.0F;
         }
         if (hurtAngle > 0.0F) {
-            GL11.glRotated(((Math.sin(hurtAngle) * hurtAngle * currentDamage) / 10F) * (float) minecart.hurtDirection, 1.0F, 0.0F, 0.0F);
+            GLRenderer.modelM4f().rotateX((float) org.joml.Math.toRadians(((Math.sin(hurtAngle) * hurtAngle * currentDamage) / 10F) * (float) minecart.hurtDirection));
         }
         // Render block in cart
         if (minecart.getType() != EntityMinecart.PASSENGER_CART) {
-            TextureRegistry.blockAtlas.bind();
+            TextureRegistry.worldAtlas.bind();
             final float scale = 0.75F;
-            GL11.glScalef(scale, scale, scale);
-            GL11.glTranslatef(0.0F, 0.3125F, 0.0F);
-            GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
-            float brightness = 1.0f;
-            if (LightmapHelper.isLightmapEnabled()) {
-                LightmapHelper.setLightmapCoord(minecart.getLightmap(partialTick));
-            } else if (!Global.accessor.isFullbrightEnabled()) {
-                brightness = minecart.getBrightness(partialTick);
-            }
+            GLRenderer.modelM4f().scale(scale, scale, scale);
+            GLRenderer.modelM4f().translate(0.0F, 0.3125F, 0.0F);
+            GLRenderer.modelM4f().rotateY(org.joml.Math.PI_OVER_2_f);
+            GLRenderer.setLightmapCoord1i(minecart.getLightmap(partialTick));
 
-            GL11.glPushMatrix();
+            GLRenderer.pushFrame();
             if (doAFlip) {
-                GL11.glRotatef(180, 0, 1, 0);
+                GLRenderer.modelM4f().rotateY(org.joml.Math.PI_f);
             }
             switch (minecart.getType()) {
                 case EntityMinecart.CHEST_CART:
@@ -104,41 +98,42 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
                     } else {
                         block = Blocks.CHEST_PLANKS_OAK;
                     }
-                    BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, minecart.getMeta(), brightness, 1, null);
+                    BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, minecart.getMeta(), minecart.getLightmap(partialTick));
                     break;
                 case EntityMinecart.FURNACE_CART:
                     if (minecart.getFuel() > 0) {
-                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_ACTIVE).renderStandalone(tessellator, 0, brightness, 1, null);
+                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_ACTIVE).renderStandalone(tessellator, 0, minecart.getLightmap(partialTick));
                     } else {
-                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_IDLE).renderStandalone(tessellator, 0, brightness, 1, null);
+                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_IDLE).renderStandalone(tessellator, 0, minecart.getLightmap(partialTick));
                     }
                     break;
             }
-            GL11.glPopMatrix();
-            GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
-            GL11.glTranslatef(0.0F, -0.3125F, 0.0F);
-            GL11.glScalef(1.0F / scale, 1.0F / scale, 1.0F / scale);
+            GLRenderer.popFrame();
+            GLRenderer.modelM4f().rotateY(-org.joml.Math.PI_OVER_2_f);
+            GLRenderer.modelM4f().translate(0.0F, -0.3125F, 0.0F);
+            GLRenderer.modelM4f().scale(1.0F / scale, 1.0F / scale, 1.0F / scale);
         }
         bindTexture("/assets/minecraft/textures/entity/cart.png");
-        GL11.glScalef(1 / 16f, 1 / 16f, -1 / 16f);
-        getModel("main").render(tessellator);
-        GL11.glPopMatrix();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.modelM4f().scale(1 / 16f, 1 / 16f, -1 / 16f);
+        getModel("main").render();
+        GLRenderer.popFrame();
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    private static void drawDebugVec(final @NotNull Tessellator tessellator, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final double scale, final float r, final float g, final float b, final float a) {
-        GL11.glLineWidth(10);
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
-        tessellator.startDrawing(GL11.GL_LINES);
-        tessellator.setColorRGBA_F(r, g, b, a);
+    private static void drawDebugVec(final @NotNull TessellatorGeneral tessellator, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final double scale, final float r, final float g, final float b, final float a) {
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.LINES);
+        GLRenderer.setLineWidth(10);
+        tessellator.startDrawing(DrawMode.LINES);
+        tessellator.setColor4f(r, g, b, a);
         tessellator.addVertex(start.x(), start.y(), start.z());
         tessellator.addVertex(
             start.x() + end.x() * scale,
             start.y() + end.y() * scale,
             start.z() + end.z() * scale);
         tessellator.draw();
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        GL11.glEnable(GL11.GL_LIGHTING);
+        GLRenderer.popFrame();
+        GLRenderer.globalSetLightEnabled(true);
     }
 }
